<template>
	<div>
		<v-snackbar v-model="snack" :timeout="timeout" top color="blue">Puntaje actualizado</v-snackbar>
		<v-dialog v-model="visibleForm" persistent max-width="450">
			<v-card>
				<v-card-title>
					Puntaje de:
					<p>{{institute}}</p>
				</v-card-title>
				<v-card-text>
					<v-row justify="space-around">
						<v-col cols="12" sm="5">
							<v-text-field label="Valor" :value="valor" v-model="value" outlined type="number" min="0" />
						</v-col>
						<v-col cols="12" sm="5">
							<v-btn :loading="loading" color="green" block outlined @click="updateScore">
								Actualizar
								<template v-slot:loader>
									<span>Actualizando...</span>
								</template>
							</v-btn>
						</v-col>
					</v-row>
				</v-card-text>
			</v-card>
		</v-dialog>
	</div>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";

export default {
	name: "ModalUpdateScoreInstitute",
	props: ["visibleForm", "institute", "valor"],
	data: () => ({
		value: 0,
		snack: false,
		timeout: 2000,
		loading: false
	}),
	watch: {
		valor: function(val) {
			this.value = this.valor;
		}
	},
	methods: {
		// obtiene el puntaje
		async getScore() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($institute: String!) {
							getValueInstitute(institute: $institute)
						}
					`,
					variables: {
						institute: this.institute
					}
				});
				this.value = data.getValueInstitute;
			} catch (error) {}
		},
		// actualiza el puntaje
		async updateScore() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($institute: String!, $value: Int!) {
							changeValueInstitute(
								institute: $institute
								value: $value
							)
						}
					`,
					variables: {
						institute: this.institute,
						value: parseInt(this.value, 10)
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					this.snack = true;
					setTimeout(() => {
						this.closeModal();
					}, 1000);
				}, 2000);
			} catch (error) {}
		},
		// cierra el modal
		closeModal() {
			EventBus.$emit("closeModalUpdateScoreInstitute");
		}
	},
	mounted() {
		// cierra el formulario de nueva carrera
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeModal();
			}
		});
	}
};
</script>